#!/usr/bin/perl

###############################################################################
#                                                                             #
#               Dimke's Zitate-Generator Version 4.1a                         #
#                                                                             #
#               All rights reserved. Copyright (C) 2004-2007                  #
#               Dipl.-Ing. Markus Robert Keler                               #
#               Bad Schussenried, Germany                                     #
#                                                                             #
#               For latest updates see http://developer.dipl-ing-kessler.de   #
#                                                                             #
###############################################################################
#                                                                             #
#               Purpose:                                                      #
#                                                                             #
#               Send quotations ("Zitate") at a given time to a given         #
#               list of email addresses. Therefore invoke zitate.pl via       #
#               unix crontab, which is also running on every linux machine    #
#                                                                             #
###############################################################################

require "/Kompletter_Pfad/zitate.cfg";

$mailprog       = '/usr/sbin/sendmail';

### Prepare date information ##################################################
@shortdays = qw( Son Mon Die Mit Don Fre Sam );
@longdays = qw( Sonntag Montag Dienstag Mittwoch Donnerstag Freitag Samstag );
@shortmonths = qw( Jan Feb Mar Apr Mai Jun Jul Aug Sep Okt Nov Dez);
@longmonths = qw( Januar Februar Mrz April Mai Juni Juli August September Oktober November Dezember);
( $sec, $min, $hr, $mday, $mon, $year, $wday, $yday, $isdst ) = localtime(time);
$longyr = $year + 1900;
$fixmo  = $mon + 1;
$yr2 = substr( $longyr, 2, 2 );

srand(time() ^ ($$ + ($$ << 15)) );

### Load email addresses ######################################################
open(EmailFile,$to_file) or die "Couldn't open $to_file: $!\n";
@emails=<EmailFile>;
close(EmailFile);
$ToField='';
foreach $i (@emails) {
   chomp($i);
   $ToField .= "$i,";
}
close(EmailFile);

open(EmailFile,$bcc_file) or die "Couldn't open $bcc_file: $!\n";
@emails=<EmailFile>;
close(EmailFile);
$BccField='';
foreach $i (@emails) {
   chomp($i);
   $BccField .= "$i,";
}
close(EmailFile);

### Load last used indexes ####################################################
open(IndexFILE, $index_file) or die "Can't open $index_file: $!\n";
@last_used_indexes=<IndexFILE>;
close(IndexFILE);

### Load phrases file #########################################################
open(PhrasFILE, $random_file) or die "Can't open $random_file: $!\n";
@phrases;
{
   local $/ = $delimiter;
   chomp (@phrases = <PhrasFILE>);
}
close(PhrasFILE);
$phrases_max_index=$#phrases;

if($repetition_min > $phrases_max_index) {
   print "Repetition time exceeds number of entries!\nProgram terminating.\n";
   exit;
}

###############################################################################

do {
   $phras_index = int(rand(@phrases));       ### Index for selecting phrase ###
   $index_already_used = 0;
   $counter = 0;
   foreach $i (@last_used_indexes) {
      chomp($i);
      if ($i == $phras_index && $counter<$repetition_min) {
         $index_already_used = 1;  ### Only as many last_used_indexes as    ###
         break;                    ### specified by $repetition_min         ###
      }
      $counter++;
   }
} while ($index_already_used == 1);

### Store current and remaining last used indexes #############################
open(IndexFILE, ">$index_file") or die "Can't open $index_file: $!\n";
print IndexFILE "$phras_index\n";  ### Current phras_index at the front     ###

$counter = 1;
foreach $i (@last_used_indexes) {
   if ($counter<$repetition_min) {
      print IndexFILE "$i\n";      ### Write last_used_indexes to indexfile ###
   }
   $counter++;
}

close(IndexFILE);

$phrase_txt = $phrases[$phras_index];

$phrase_html = $phrase_txt;
$phrase_html =~ s/\n/\<br\>/g;

$betreffzeile_komplett = sprintf ("%s - %3s.,%02d.%3s.%02d", $betreff, $shortdays[$wday], $mday, $shortmonths[$mon], $yr2 );
$datum_komplett = sprintf ("%s, der %d. %s %4d", $longdays[$wday], $mday, $longmonths[$mon], $longyr);

$hintergrund = $hintergruende[int(rand(@hintergruende))];
$clipart = $cliparts[int(rand(@cliparts))];
$sound_file = $sounds[int(rand(@sounds))];

## Open Mail ##################################################################

   open (MAIL, "|$mailprog -t") || die "Can't open $mailprog!\n";

   print MAIL "From: $from\n";
   print MAIL "Reply-to: $from\n";
   print MAIL "To: $ToField\n";
   print MAIL "Bcc: $BccField\n";
   print MAIL "X-Mailer: Zitate-Generator 4.1a, (C) 2004-2007, Dipl.-Ing. Markus Robert Kessler\n";
   print MAIL "X-Complaints-To: abuse\@dipl-ing-kessler.de\n";
   print MAIL "Subject: $betreffzeile_komplett\n";
   print MAIL "MIME-Version: 1.0\n";
   print MAIL "Content-Type: multipart/alternative\; boundary=boundary42\n\n";

## Text only ##################################################################

   print MAIL "--boundary42\n";
   print MAIL "Content-Type: text/plain; charset=\"iso-8859-1\"\n\n";

   print MAIL "$einleitung_txt\n\n";
   print MAIL "Heute ist $datum_komplett.\n\n";
   print MAIL "Und hier das Zitat des Tages:\n\n";
   print MAIL "$phrase_txt\n";
   print MAIL "$schluss_txt\n";
   print MAIL "$signatur_txt\n";

## HTML mail ##################################################################

   print MAIL "--boundary42\n";
   print MAIL "Content-Type: text/html; charset=\"iso-8859-1\"\n\n";

   print MAIL "<html>\n";
   print MAIL "<head>\n";
   print MAIL "<title>$betreffzeile_komplett</title>\n";

   if($sound_yes_no eq 'yes') {
      print MAIL "<bgsound src=\"$sound_path/$sound_file\" loop=\"1\">\n";
   }

   print MAIL "</head>\n";

   print MAIL "<body bgcolor=\"#ffffbf\" background=\"$background_path/$hintergrund\">\n";

   if($sound_yes_no eq 'yes') {
      print MAIL "<embed src=\"$sound_path/$sound_file\" autostart=\"true\" loop=\"1\" hidden=\"true\" height=\"0\" width=\"0\">\n";
   }

   print MAIL "<table width=100\% border=0><tr><td align=center bgcolor=\"#00ff00\">\n";
   print MAIL "<font face=\"Arial,Helvetica\" size=4 Color=Red><b>Zitate-Generator 4.1a</td></tr></table><br>\n";
   print MAIL "<img align=right src=\"$clipart_path/$clipart\">\n";
   print MAIL "$einleitung_html<p>\n";
   print MAIL "Heute ist $datum_komplett.<p>\n";
   print MAIL "Und hier das Zitat des Tages:<p>\n";
   print MAIL "<table border=2 width=495><tr><td align=center>\n";
   print MAIL "$phrase_font$phrase_html\n";
   print MAIL "</td></tr></table><p>\n";
   print MAIL "$schluss_html<p>\n";
   print MAIL "<table width=100\% border=0><tr><td align=center bgcolor=\"#00ff00\">\n";
   print MAIL "<font face=\"Arial,Helvetica\" size=2 Color=Red>\n";
   print MAIL "$signatur_html</td></tr></table><br>\n";
   print MAIL "</BODY></HTML>\n";

   close (MAIL);
 
   # Print Confirmation of delivery

   print "\nMessage has been sent\n\n";
   print "To:\n$ToField\n\n";
   print "Bcc:\n$BccField\n\n";
   print "OK.\n\n";

exit;

